'
' FILE: AllUsers-ForcePasswordChange.vbs
' AUTHOR: Brian Arriaga
' CREATED: 18 October 2016
' MODIFIED:  18 October 2016
' ORIGINALLY CREATED FOR: EFT Server 6.5-7.3
' PURPOSE: This script loops through all Users of a specified site and performs ForcePasswordChange to force all users to change their password at next login.
' 
' NOTE: The creation and modification of COM API scripts is not within the standard scope of Support.
' All COM API scripts are supplied as a courtesy "AS IS" with no implied or explicit guarantee of function.
' GlobalSCAPE is not responsible for any damage to system or data as a result of using supplied COM API scripts.
' Further information and usage instruction on COM API methods can be found online within the help file: http://help.globalscape.com/help/
'

Set SFTPServer = WScript.CreateObject("SFTPCOMInterface.CIServer")


'Modify the below connection details to reflect your own environment.
   txtServer = "localhost"
   txtPort =  "1100"
   txtAdminUserName = "a"
   txtAdminPassword = "a"
   txtSiteName = "MySite"
   
Dim theSite

Call ConnectToServer()
Call FindSite()
Call LoopAllUsersAndForcePasswordReset()

SFTPServer.Close
Set SFTPServer = nothing

'==========================================
'This sub connects to the server
'=========================================
Sub ConnectToServer()
	SFTPServer.Connect txtServer, txtPort, txtAdminUserName, txtAdminPassword

	WScript.Echo "Connected to EFT Server: "  & txtServer
End Sub


'==========================================
'This sub finds the specified site
'=========================================
Sub FindSite()	
	set Sites=SFTPServer.Sites

	For i = 0 to SFTPServer.Sites.Count-1
	   set theSite=Sites.Item(i)
	   if LCase(Trim(theSite.Name)) = LCase(Trim(txtSiteName)) then
			exit for
		End if
	Next	
	WScript.Echo "Connected to site: " & theSite.Name
End Sub
	
	
'==========================================
'This sub Lists all Users and then issues ForcePasswordChange to prompt user to change password at next login.
'=========================================	
Sub LoopAllUsersAndForcePasswordReset()

	Dim arSiteUsers : arSiteUsers = theSite.GetUsers()
		for t = LBound(arSiteUsers) to UBound(arSiteusers)
						
				'The below lines perform the GetUserSettingsLevel() method. This gathered the settings level info of the individual user. This is nested within the above "GetUser" loop, so it will 
				'go through each user of the site. Within each loop, the ForcePasswordChange method is called.
					
				set userSettings = theSite.GetUserSettings(arSiteUsers(t))
				userSettings.ForcePasswordChange
				
				'Spits it out for info purposes only
				WScript.Echo "User: "&arSiteUsers(t)&" will be asked to change password at next login"

		Next
End Sub
