'
' FILE: ExportAllUsers-GetForcePasswordResetOnInitialLogon.vbs
' AUTHOR: Brian Arriaga
' CREATED: 10 July 2017
' MODIFIED:  10 July 2017
' ORIGINALLY CREATED FOR: EFT Server 7.3.+
' PURPOSE: This script exports all users Password Reset on Initial Logon setting.
' 
' NOTE: The creation and modification of COM API scripts is not within the standard scope of Support.
' All COM API scripts are supplied as a courtesy "AS IS" with no implied or explicit guarantee of function.
' GlobalSCAPE is not responsible for any damage to system or data as a result of using supplied COM API scripts.
' Further information and usage instruction on COM API methods can be found online within the help file: http://help.globalscape.com/help/
'

Set SFTPServer = WScript.CreateObject("SFTPCOMInterface.CIServer")


'Modify the below connection details to reflect your own environment.
   txtServer = "localhost"
   txtPort =  "1100"
   txtAdminUserName = "a"
   txtAdminPassword = "a"
   txtSiteName = "MySite"
   txtUserName = "a"
   txtFile = "C:\temp\GetForcePasswordResetOnInitialLogon.csv"

'Dim allows variables to be visable by all procedures and submethods. This allows oPRS created in GetPassResetSettings() to be used in GetMaxPasswordAgeDays()
Dim theSite
Dim CurrentUser
g_strBuffer =""   
Dim userSettings
Dim userSettingTemplate
Dim TemplateSettings

'Get File Object
Set objFSO = CreateObject("Scripting.FileSystemObject")

'Create/overwrite log file
Set objLogFile = objFSO.CreateTextFile(txtFile, True)

Call ConnectToServer()
Call FindSite()
Call LoopUsers()

SFTPServer.Close
Set SFTPServer = nothing


'==========================================
'This sub connects to the server
'=========================================
Sub ConnectToServer()
	SFTPServer.Connect txtServer, txtPort, txtAdminUserName, txtAdminPassword

	WScript.Echo "Connected to EFT Server: "  & txtServer
End Sub


'==========================================
'This sub finds the specified site
'=========================================
Sub FindSite()	
	set Sites=SFTPServer.Sites

	For i = 0 to SFTPServer.Sites.Count-1
	   set theSite=Sites.Item(i)
	   if LCase(Trim(theSite.Name)) = LCase(Trim(txtSiteName)) then
			exit for
		End if
	Next	
	WScript.Echo "Connected to site: " & theSite.Name
End Sub
	
'==========================================
'Loop through all users on the site
'=========================================
Sub LoopUsers()	

	g_strBuffer= "User,Allow Users to reset their passwords,Allow Users to reset their passwords(inherited?),ChangePass-first time pass,ChangePass-first time pass(inherit),ChangePass-Next use"
	objLogFile.WriteLine(g_strBuffer)

	WScript.Echo "Getting Users Password Reset Settings"
	Dim arSiteUsers : arSiteUsers = theSite.GetUsers()
	for t = LBound(arSiteUsers) to UBound(arSiteusers)
		'WScript.Echo "User# "&CStr(t) & " - " & arSiteUsers(t)
		CurrentUser = arSiteUsers(t)
		
		Call GetUserSettings(t)
		Call GetForcePasswordResetOnLogin()
	Next
	
	
End Sub

	
'==========================================
'This sub sets the user account so that UserSettings can be queried.
'=========================================	
Sub GetUserSettings(t)
	
	WScript.Echo ""
	WScript.Echo "***Getting user Settings for: " & CurrentUser
	set userSettings = theSite.GetUserSettings(CurrentUser)

End Sub

'==========================================
'This sub Gets info on whether or not the user can change their password and if they will be required to change password at next login.
'=========================================	
Sub GetForcePasswordResetOnLogin()
					
		bEnabled = userSettings.GetChangePwd(bInherited)
		cEnabled = userSettings.GetForcePasswordResetOnInitialLogin(cInherited)
		dEnabled = userSettings.GetForcePasswordResetOnNextLogin
		
		WScript.Echo ""
		WScript.Echo userSettings.GetChangePwd
		WScript.Echo "user " & CurrentUser & " can change password = "& bEnabled
		WScript.Echo "user " & CurrentUser & " can change password (inherited?): "& bInherited
		
		WScript.Echo ""
		WScript.Echo userSettings.GetForcePasswordResetOnInitialLogin
		WScript.Echo "user " & CurrentUser & "'s Password reset on initial logon: "& cEnabled
		WScript.Echo "user " & CurrentUser & "'s Password reset on initial logon (inherited?): "& cInherited
		

		WScript.Echo ""
		WScript.Echo userSettings.GetForcePasswordResetOnNextLogin
		WScript.Echo "user " & CurrentUser & "'s Password reset on next logon: "& dEnabled
		
		g_strBuffer= CurrentUser&","&bEnabled&","&bInherited&","&cEnabled&","&cInherited&","&dEnabled
		objLogFile.WriteLine(g_strBuffer)

End Sub
